package org.artifactory.core.api.ph.model;

import org.artifactory.core.api.ph.virtual.resolution.PackageRequestContext;

import javax.annotation.concurrent.Immutable;
import java.util.Objects;

@Immutable
public class PackageDownloadContext implements PackageRequestContext {
    private final String path;
    private final String repoKey;

    public PackageDownloadContext(String repoKey, String path) {
        this.repoKey = repoKey;
        this.path = path;
    }

    public String getPath() {
        return path;
    }

    public String getRepoKey() {
        return repoKey;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        PackageDownloadContext context = (PackageDownloadContext) o;
        return Objects.equals(path, context.path) && Objects.equals(repoKey, context.repoKey);
    }

    @Override
    public int hashCode() {
        return Objects.hash(path, repoKey);
    }
}
